draw_background:
        dec     byte [bgy]              ; advance background
        mov     di,scrn+1023
        mov     cx,16

        mov     bl,[bgy]
        and     bx,0xf0                 ; BX = map's offset to block #

.draw_column:
        push    cx
        push    bx

        mov     dl,[bgy]                ; DL = map Y coordinate
        shr     dl,1
        and     dx,7                    ; DX = # of lines skipped in block
        mov     cx,8
        sub     cx,dx                   ; CX = # rows remaining in block
        call    .draw_partial_block

.dr:    add     bl,0x10
        mov     cx,8
        xor     dx,dx
        call    .draw_partial_block
        jmp     .dr

.done:  pop     bx
        inc     bl
        add     di,1023
        pop     cx
        loop    .draw_column
        ret

.draw_partial_block:
        mov     si,starmap
        add     si,bx

        xor     ah,ah
        lodsb                           ; AL = block at this position
        mov     si,startiles
        shl     ax,4
        add     si,ax                   ; SI -> start of block
        add     si,dx                   ; skip given # of rows

.dpbl:  movsb
        mov     al,[si+7]
        mov     [di+1023],al
        add     di,-17
        cmp     di,scrn
        jc      .endreached
        loop    .dpbl
        ret

.endreached:
        pop     bx
        jmp     .done

draw_foreground:
        dec     byte [fgy]              ; advance position
        dec     byte [fgy]
        mov     di,scrn+1023
        mov     cx,16

        mov     bl,[fgy]
        and     bx,0xf0                 ; BX = map's offset to block #

.draw_column:
        push    cx
        push    bx

        mov     dl,[fgy]                ; DL = map Y coordinate
        shr     dl,1
        and     dx,7                    ; DX = # of lines skipped in block
        mov     cx,8
        sub     cx,dx                   ; CX = # rows remaining in block
        call    .draw_partial_block

.dr:    add     bl,0x10
        mov     cx,8
        xor     dx,dx
        call    .draw_partial_block
        jmp     .dr

.done:  pop     bx
        inc     bl
        add     di,1023
        pop     cx

        cmp     cx,15
        jne     .ok
        mov     cx,3
        add     bl,12
        add     di,-12
.ok:    loop    .draw_column
        ret

.draw_partial_block:
        mov     si,fgmap
        add     si,bx

        xor     ah,ah
        lodsb                           ; AL = block at this position
        mov     si,fgtiles
        shl     ax,4
        add     si,ax                   ; SI -> start of block
        add     si,dx                   ; skip given # of rows

.dpbl:  lodsb
        or      [di],al
        not     al
        and     [di+1024],al
        mov     al,[si+7]
        or      [di+1024],al
        add     di,-16
        cmp     di,scrn
        jc      .endreached
        loop    .dpbl
        ret

.endreached:
        pop     bx
        jmp     .done

startiles:
        INCBIN  'startile.bin'
starmap:
%include 'starmap.i'
fgtiles:
        INCBIN  'fgtile.bin'
fgmap:
%include 'fgmap.i'
