;------ Platinum Editon for Casio Algebra FX 2.0 - Enemy bullets
;
; Programmed by Patrick Davidson (pad@ocf.berkeley.edu)
;
; This software is in the public domain.  There is no warranty.

;------ handle enemy bullets

enemy_bullets:
        mov     si,f_array
        mov     cx,f_count
.enemy_bullet_loop:
        push    cx

        push    si
        lodsb
        cbw
        add     ax,ax
        mov     di,enemy_bullet_table
        add     di,ax
        push    word .bullet_code_run
        jmp     [di]
.bullet_code_run:
        pop     si

        lodsb
        or      al,al
        jz      .no_enemy_bullet

        push    si
        mov     al,[si+f_y-1]
        mov     cl,[si+f_x-1]
        mov     si,[si+f_image-1]
        call    display_sprite_8
        pop     si

        mov     bh,[px]
        mov     dh,[py]
        mov     bl,9
        mov     dl,7
        call    collision_check
        jnc     .no_enemy_bullet
        mov     al,[si-1]
        mov     byte [si-1],0
        or      al,al
        jl      .bonus_collected
        dec     byte [player_shield]

.no_enemy_bullet:
        pop     cx
        add     si,f_size-1
        loop    .enemy_bullet_loop
        ret

.bonus_collected:
        mov     di,[cash]
        add     di,50
        mov     [cash],di
        jmp     .no_enemy_bullet

        dw      enemy_bullet_slow
enemy_bullet_table:
        dw      enemy_bullet_none
        dw      enemy_bullet_normal
        dw      enemy_arrow_shot

enemy_bullet_slow:
        mov     al,[game_timer]
        and     al,1
        jz      enemy_bullet_normal
enemy_bullet_none:
        ret

enemy_arrow_shot:
        inc     byte [si+f_y-1]

enemy_bullet_normal:
        mov     al,[si+f_x-1]
        add     al,[si+f_dx-1]
        mov     [si+f_x-1],al
        jl      .enemy_bullet_destroy
        cmp     al,125
        jnc     .enemy_bullet_destroy
        mov     al,[si+f_y-1]
        inc     al
        cmp     al,SCREEN_TOP+SCREEN_HEIGHT
        jge     .enemy_bullet_destroy
        mov     [si+f_y-1],al
        ret

.enemy_bullet_destroy:
        mov     byte [si-1],0
        ret

;------ locate an unused bullet

find_enemy_bullet:
        mov     cx,f_count
        mov     di,f_array
        mov     dx,f_size
.loop:  mov     al,[di]
        or      al,al
        je      .q
        add     di,dx
        loop    .loop
.q:     ret

;------ fire an aimed enemy bullet from (BH,BL)

enemy_aim_shoot:
        call    find_enemy_bullet
        jnz     .q
        mov     byte [di],1
        mov     [di+f_x],bh
        mov     byte [di+f_w],2
        mov     [di+f_y],bl
        mov     byte [di+f_h],2
        mov     byte [di+f_dx],0
        mov     word [di+f_image],enemy_bullet_image
        sub     bh,[px]
        cmp     bh,20
        jg      .go_left
        cmp     bh,-27
        jl      .go_right
.q      ret
.go_left:
        mov     byte [di+f_dx],-1
        ret
.go_right:
        mov     byte [di+f_dx],1
        ret

;------ images

enemy_bullet_image:
        db      3
        dw      1100000000000000b
        dw      1100000000000000b
        dw      1100000000000000b

enemy_arrow_image:
        db      8
        dw      1010000000000000b
        dw      1010000000000000b
        dw      1110000000000000b
        dw      0100000000000000b
        dw      0100000000000000b
        dw      0100000000000000b
        dw      1110000000000000b
        dw      0100000000000000b

bonus_image:
        db      7
        dw      0010000000000000b
        dw      0111100000000000b
        dw      1010000000000000b
        dw      0111000000000000b
        dw      0010100000000000b
        dw      1111000000000000b
        dw      0010000000000000b
