;------ Platinum Editon for Casio Algebra FX 2.0 - Enemies
;
; Programmed by Patrick Davidson (pad@ocf.berkeley.edu)
;
; This software is in the public domain.  There is no warranty.

;------ enemy types

        dw      enemy_exploding
enemy_table:
        dw      return_ss
        dw      enemy_1         ;1
        dw      boss_1          ;2
        dw      bounce          ;3
        dw      enemy_arrow     ;4
        dw      spinner_normal  ;5
        dw      spinner_rampage ;6
        dw      cross_enemy     ;7

;------ bouncing enemies

bounce: mov     al,[si+e_dx-1]
        or      al,[game_timer]
        and     al,1
        jz      .nox
        cmp     byte [si+e_dx-1],2
        jl      .left

        inc     byte [si+e_x-1]
        cmp     byte [si+e_x-1],101
        jnz     .nox
        push    si
        call    random_number
        pop     si
        and     al,1
        mov     [si+e_dx-1],al
        jmp     .nox

.left:  dec     byte [si+e_x-1]
        cmp     byte [si+e_x-1],17
        jnz     .nox
        push    si
        call    random_number
        pop     si
        and     al,1
        add     al,2
        mov     [si+e_dx-1],al

.nox:   mov     al,[si+e_dy-1]
        or      al,[game_timer]
        and     al,1
        jz      .noy
        cmp     byte [si+e_dy-1],2
        jl      .up

        inc     byte [si+e_y-1]
        cmp     byte [si+e_y-1],55
        jnz     .noy
        push    si
        call    random_number
        pop     si
        and     al,1
        mov     [si+e_dy-1],al
        jmp     .noy

.up:    dec     byte [si+e_y-1]
        cmp     byte [si+e_y-1],32

        jnz     .noy
        push    si
        call    random_number
        pop     si
        and     al,1
        add     al,2
        mov     [si+e_dy-1],al

.noy:   push    si
        call    random_number
        pop     si
        and     al,252
        jnz     .ns
        mov     bl,[si+e_y-1]
        mov     bh,[si+e_x-1]
        add     bx,0x305
        jmp     enemy_aim_shoot
.ns:    ret

;------ bosses

boss_1: call    boss_move
        push    si
        call    random_number
        pop     si
        and     al,31
        jnz     .no_shoot
        mov     bl,[si+e_y-1]
        mov     bh,[si+e_x-1]
        add     bx,0x207
        call    enemy_aim_shoot
        mov     bl,[si+e_y-1]
        mov     bh,[si+e_x-1]
        add     bx,0xd07
        call    enemy_aim_shoot
.no_shoot:
        mov     al,[si+e_y-1]
        mov     cl,[si+e_x-1]
        add     cl,9
        mov     si,[si+e_image-1]
        add     si,41
        jmp     display_sprite_gray

boss_move:
        mov     al,[si+e_phase-1]
        dec     al
        jz      .right
        dec     al
        jz      .left
        dec     byte [si+e_timer-1]
        jnz     .nn
        inc     byte [si+e_phase-1]
.nn:    jmp     enemy_1_move.go_down

.right: mov     al,[si+e_x-1]
        inc     al
        mov     [si+e_x-1],al
        cmp     al,81
        jnz     .q
        inc     byte [si+e_phase-1]
.q:     ret

.left:  mov     al,[si+e_x-1]
        dec     al
        mov     [si+e_x-1],al
        cmp     al,17
        jnz     .q
        dec     byte [si+e_phase-1]
        ret

;------ normal enemy movement

enemy_1_move:
        dec     byte [si+e_timer-1]
        jge     .same_phase
        mov     byte [si+e_timer-1],16
        mov     al,[si+e_phase-1]
        inc     al
        and     al,3
        mov     [si+e_phase-1],al
.same_phase:
        mov     al,[si+e_phase-1]
        dec     al
        jz      .go_right
        dec     al
        jz      .go_up
        dec     al
        jz      .go_left
.go_down:
        mov     al,[game_timer]
        and     al,1
        jz      .q
        inc     byte [si+e_y-1]
.q:     ret
.go_right:
        inc     byte [si+e_x-1]
        ret
.go_up: mov     al,[game_timer]
        and     al,1
        jz      .q
        dec     byte [si+e_y-1]
        ret
.go_left:
        dec     byte [si+e_x-1]
        ret

;------ exploding enemy

enemy_exploding:
        dec     byte [si+e_timer-1]
        jz      .q
        mov     byte [si+e_timer-1],3
        mov     di,[si+e_image-1]
        add     di,25
        mov     [si+e_image-1],di
        cmp     di,explode_end
        jnz     .q
        mov     byte [si-1],0
        inc     word [score]

        push    si
        call    random_number
        pop     si
        and     al,7
        jnz     .q
        call    find_enemy_bullet
        jnz     .q
        mov     al,-1
        stosb
        movsb
        mov     al,5
        stosb
        inc     si
        movsb
        mov     al,7
        stosb
        xor     al,al
        stosb
        mov     ax,bonus_image
        stosw
.q:     ret

;------ normal enemy

enemy_1:
        call    enemy_1_move
        push    si
        call    random_number
        pop     si
        and     al,127
        jnz     .q
        call    find_enemy_bullet
        jne     .q
        mov     al,1
        stosb
        mov     al,[si+e_x-1]
        add     al,2
        stosb
        mov     al,2
        stosb
        mov     al,[si+e_y-1]
        add     al,3
        stosb
        mov     al,2
        stosb
        xor     al,al
        stosb
        mov     ax,enemy_bullet_image
        stosw
.q:     ret

;------ movement of "crazed" enemy

enemy_crazy_move:
        mov     bl,[si+e_y-1]
        cmp     bl,[restrict]
        jge     .notop
        mov     byte [si+e_dy-1],1
.notop: cmp     bl,49
        jne     .nymid
        push    si
        call    random_number
        pop     si
        and     al,2
        dec     al
        mov     [si+e_dy-1],al
.nymid: cmp     bl,55
        jle     .nbot
        mov     byte [si+e_dy-1],-1
.nbot:  add     bl,[si+e_dy-1]
        mov     [si+e_y-1],bl
        
        mov     bl,[si+e_x-1]
        cmp     bl,16
        jge     .nl
        mov     byte [si+e_dx-1],1
.nl:    cmp     bl,45
        je      .xmid
        cmp     bl,73
        jne     .nxmid
.xmid:  push    si
        call    random_number
        pop     si
        and     al,2
        dec     al
        mov     [si+e_dx-1],al
.nxmid: cmp     bl,103
        jle     .nr
        mov     byte [si+e_dx-1],-1
.nr:    add     bl,[si+e_dx-1]
        mov     [si+e_x-1],bl
        ret

;------ cross enemy control

cross_enemy:
        call    enemy_crazy_move
        push    si
        call    random_number
        pop     si
        and     al,127
        jz      spinner_normal.shoot
        ret

;------ spinning enemy control

spinner_rampage:
        call    rotate_image
        call    enemy_crazy_move
        push    si
        call    random_number
        pop     si
        and     al,126
        jz      spinner_normal.shoot
        ret

spinner_normal:
        call    rotate_image
        call    enemy_1_move
        push    si
        call    random_number
        pop     si
        or      al,al
        jnz     .q
.shoot: mov     bl,[si+e_y-1]
        mov     bh,[si+e_x-1]
        add     bx,0x304
        jmp     enemy_aim_shoot
.q:     ret

;------ rotate the image (sequence of four 9-byte sprites)

rotate_image:
        xor     cl,[game_timer]
        and     cl,1
        jz      .nni
        mov     di,[si+e_image-1]
        add     di,33
        mov     al,[di]
        or      al,al
        jnz     .ok
        sub     di,132
.ok:    mov     [si+e_image-1],di
.nni:   ret

;------ arrow-launching enemy

enemy_arrow:
        call    enemy_1_move
        push    si
        call    random_number
        pop     si
        and     al,255
        jnz     .q
        call    find_enemy_bullet
        jne     .q
        mov     al,2
        stosb
        mov     al,[si+e_x-1]
        add     al,2
        stosb
        mov     al,3
        stosb
        mov     al,[si+e_y-1]
        add     al,3
        stosb
        mov     al,8
        stosb
        xor     al,al
        stosb
        mov     ax,enemy_arrow_image
        stosw
.q:     ret

;------ process enemies (main loop)

process_enemies:
        mov     byte [enemies_left],0
        mov     si,e_array
        mov     cx,e_count
enemy_loop:
        push    cx
        push    si
        lodsb
        cbw
        add     ax,ax
        mov     di,enemy_table
        add     di,ax
        push    word enemy_done
        jmp     [di]
enemy_done:
        pop     si
        push    si
        lodsb
        or      al,al
        jz      no_enemy_here
        inc     byte [enemies_left]
        mov     cl,[si+e_x-1]
        mov     al,[si+e_y-1]
        mov     si,[si+e_image-1]
        call    display_sprite_gray
no_enemy_here:
        pop     si
        pop     cx
        add     si,e_size
        loop    enemy_loop

        mov     al,[enemies_left]       ; spinners rampage if enemies
        sub     al,8                    ; remaining falls below 9
        jge     .norampage
        mov     si,e_array
        mov     cx,e_count
.rampageloop:
        cmp     byte [si],5
        jnz     .notthisone
        inc     byte [si]
        mov     word [si+e_dx],-1
.notthisone:
        add     si,e_size
        loop    .rampageloop
.norampage:

        mov     al,[enemies_left]
        or      al,al
        jz      load_new_level
        ret

load_new_level:
        mov     al,[level_number]
        inc     al
        mov     [level_number],al
        cbw
        add     ax,ax
        mov     di,level_table-2
        add     di,ax
        jmp     [di]

;------ images

        db      7
enemy_4_image:
        db      10
        dw      1000001000000000b
        dw      1000001000000000b
        dw      1100011000000000b
        dw      1100011000000000b
        dw      1111111000000000b
        dw      1011101000000000b
        dw      1111111000000000b
        dw      1000001000000000b
        dw      1111111000000000b
        dw      1000001000000000b
        dw      1111111000000000b
        dw      1000001000000000b
        dw      1111111000000000b
        dw      1111111000000000b
        dw      1111111000000000b
        dw      1000001000000000b
        dw      0111110000000000b
        dw      0100010000000000b
        dw      0011100000000000b
        dw      0011100000000000b

        db      5
enemy_3_image:
        db      5
        dw      1000100000000000b
        dw      1000100000000000b
        dw      1111100000000000b
        dw      1000100000000000b
        dw      1111100000000000b
        dw      1000100000000000b
        dw      0111000000000000b
        dw      0101000000000000b
        dw      0010000000000000b
        dw      0010000000000000b

        db      7
enemy_1_image:
        db      7
        dw      1000001000000000b
        dw      1000001000000000b
        dw      1100011000000000b
        dw      1100011000000000b
        dw      1111111000000000b
        dw      1111111000000000b
        dw      1111111000000000b
        dw      1000001000000000b
        dw      1111111000000000b
        dw      1000001000000000b
        dw      0111110000000000b
        dw      0100010000000000b
        dw      0011100000000000b
        dw      0011100000000000b

        db      8
enemy_2_image:
        db      6
        dw      1000000100000000b
        dw      1000000100000000b
        dw      1101101100000000b
        dw      1101101100000000b
        dw      1111111100000000b
        dw      1100001100000000b
        dw      1111111100000000b
        dw      1100001100000000b
        dw      1101101100000000b
        dw      1101101100000000b
        dw      1000000100000000b
        dw      1000000100000000b

enemy_bounce_image:
        db      9
        dw      0001100000000000b
        dw      0001100000000000b
        dw      0001100000000000b
        dw      0001100000000000b
        dw      0001100000000000b
        dw      0001100000000000b
        dw      0011110000000000b
        dw      0010010000000000b
        dw      0111111000000000b
        dw      0100001000000000b
        dw      1111111100000000b
        dw      1000000100000000b
        dw      1111111100000000b
        dw      1001100100000000b
        dw      1110011100000000b
        dw      1010010100000000b
        dw      1100001100000000b
        dw      1100001100000000b

boss_image_left:
        db      10
        dw      1000000000000000b
        dw      1000000000000000b
        dw      1100000000000000b
        dw      1100000000000000b
        dw      1111111110000000b
        dw      1111111110000000b
        dw      1111111110000000b
        dw      1100000110000000b
        dw      1111111110000000b
        dw      1100000010000000b
        dw      1111111110000000b
        dw      1100000010000000b
        dw      1111111110000000b
        dw      1100000010000000b
        dw      0111111110000000b
        dw      0110000010000000b
        dw      0011111110000000b
        dw      0011111110000000b
        dw      0001111110000000b
        dw      0001111110000000b

boss_image_right:
        db      10
        dw      0000000010000000b
        dw      0000000010000000b
        dw      0000000110000000b
        dw      0000000110000000b
        dw      1111111110000000b
        dw      1111111110000000b
        dw      1111111110000000b
        dw      1100000110000000b
        dw      1111111110000000b
        dw      1000000110000000b
        dw      1111111110000000b
        dw      1000000110000000b
        dw      1111111110000000b
        dw      1000000110000000b
        dw      1111111100000000b
        dw      1000001100000000b
        dw      1111111000000000b
        dw      1111111000000000b
        dw      1111110000000000b
        dw      1111110000000000b

boss_image_left_2:
        db      10
        dw      1000000000000000b
        dw      1000000000000000b
        dw      1100000000000000b
        dw      1100000000000000b
        dw      1111111100000000b
        dw      1111111100000000b
        dw      1111111100000000b
        dw      1110101100000000b
        dw      1111111100000000b
        dw      1101010100000000b
        dw      1111111100000000b
        dw      1110101100000000b
        dw      1111111100000000b
        dw      1101010100000000b
        dw      0111111100000000b
        dw      0110101100000000b
        dw      0011111100000000b
        dw      0011111100000000b
        dw      0001111100000000b
        dw      0001111100000000b

boss_image_right_2:
        db      10
        dw      0000000100000000b
        dw      0000000100000000b
        dw      0000001100000000b
        dw      0000001100000000b
        dw      1111111100000000b
        dw      1111111100000000b
        dw      1111111100000000b
        dw      1101011100000000b
        dw      1111111100000000b
        dw      1010101100000000b
        dw      1111111100000000b
        dw      1101011100000000b
        dw      1111111100000000b
        dw      1010101100000000b
        dw      1111111000000000b
        dw      1101011000000000b
        dw      1111110000000000b
        dw      1111110000000000b
        dw      1111100000000000b
        dw      1111100000000000b

boss_image_left_3:
        db      10
        dw      1111000000000000b
        dw      1111000000000000b
        dw      1111111110000000b
        dw      1111010100000000b
        dw      1111111110000000b
        dw      1111101010000000b
        dw      1111111110000000b
        dw      1111010100000000b
        dw      1111111110000000b
        dw      1111101010000000b
        dw      1111111110000000b
        dw      1111010100000000b
        dw      1111111110000000b
        dw      1111101010000000b
        dw      1110111110000000b
        dw      1110010100000000b
        dw      1100000000000000b
        dw      1100000000000000b
        dw      1000000000000000b
        dw      1000000000000000b

boss_image_right_3:
        db      10
        dw      0000011110000000b
        dw      0000011110000000b
        dw      1111111110000000b
        dw      1010111110000000b
        dw      1111111110000000b
        dw      0101011110000000b
        dw      1111111110000000b
        dw      1010111110000000b
        dw      1111111110000000b
        dw      0101011110000000b
        dw      1111111110000000b
        dw      1010111110000000b
        dw      1111111110000000b
        dw      0101011110000000b
        dw      1111001110000000b
        dw      1010001110000000b
        dw      0000000110000000b
        dw      0000000110000000b
        dw      0000000010000000b
        dw      0000000010000000b

        db      8
enemy_spin1_image:
        db      8
        dw      0010000000000000b
        dw      0010000000000000b
        dw      0011110000000000b
        dw      0011110000000000b
        dw      0111111100000000b
        dw      0111111100000000b
        db      0111111000000000b
        dw      0110011000000000b
        db      0111111000000000b
        dw      0110011000000000b
        dw      1111111000000000b
        dw      1111111000000000b
        dw      0011110000000000b
        dw      0011110000000000b
        dw      0000010000000000b
        dw      0000010000000000b
        db      8
        dw      0000100000000000b
        dw      0000100000000000b
        dw      0011110000000000b
        dw      0011110000000000b
        dw      0011110000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      1111111000000000b
        dw      1110011000000000b
        dw      0111111100000000b
        dw      0110011100000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0011110000000000b
        dw      0011110000000000b
        dw      0001000000000000b
        dw      0001000000000000b
        db      8
        dw      0000001000000000b
        dw      0000001000000000b
        dw      1011110000000000b
        dw      1011110000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0110011000000000b
        dw      0111111000000000b
        dw      0110011000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0011110100000000b
        dw      0011110100000000b
        dw      0100000000000000b
        dw      0100000000000000b
        db      8
        dw      0100000000000000b
        dw      0100000000000000b
        dw      0111111100000000b
        dw      0111111100000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0110011000000000b
        dw      0111111000000000b
        dw      0110011000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      1111111000000000b
        dw      1111111000000000b
        dw      0000001000000000b
        dw      0000001000000000b
        db      0

        db      8
enemy_cross_image:
        db      8
        dw      1100001100000000b
        dw      1100001100000000b
        dw      1110011100000000b
        dw      1110011100000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0011110000000000b
        dw      0011110000000000b
        dw      0011110000000000b
        dw      0011110000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      1110011100000000b
        dw      1110011100000000b
        dw      1100001100000000b
        dw      1100001100000000b

        db      8
enemy_spin2_image:
        db      8
        dw      0010000000000000b
        dw      0010000000000000b
        dw      0011110000000000b
        dw      0011110000000000b
        dw      0111111100000000b
        dw      0111111100000000b
        db      0111111000000000b
        dw      0111111000000000b
        db      0111111000000000b
        dw      0111111000000000b
        dw      1111111000000000b
        dw      1111111000000000b
        dw      0011110000000000b
        dw      0011110000000000b
        dw      0000010000000000b
        dw      0000010000000000b
        db      8
        dw      0000100000000000b
        dw      0000100000000000b
        dw      0011110000000000b
        dw      0011110000000000b
        dw      0011110000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      1111111000000000b
        dw      1111111000000000b
        dw      0111111100000000b
        dw      0111111100000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0011110000000000b
        dw      0011110000000000b
        dw      0001000000000000b
        dw      0001000000000000b
        db      8
        dw      0000001000000000b
        dw      0000001000000000b
        dw      1011110000000000b
        dw      1011110000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0011110100000000b
        dw      0011110100000000b
        dw      0100000000000000b
        dw      0100000000000000b
        db      8
        dw      0100000000000000b
        dw      0100000000000000b
        dw      0111111100000000b
        dw      0111111100000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      0111111000000000b
        dw      1111111000000000b
        dw      1111111000000000b
        dw      0000001000000000b
        dw      0000001000000000b
        db      0

explode_1:
        db      6
        dw      0000000000000000b      
        dw      0000000000000000b      
        dw      0011110000000000b      
        dw      0001110000000000b      
        dw      0111111000000000b      
        dw      0011011000000000b      
        dw      0111111100000000b      
        dw      0101011000000000b      
        dw      0011100000000000b      
        dw      0011100000000000b      
        dw      0000000000000000b      
        dw      0000000000000000b      
        db      6     
        dw      0011000000000000b      
        dw      0011000000000000b      
        dw      0111111100000000b      
        dw      0100111100000000b      
        dw      1111111010000000b      
        dw      1010101000000000b      
        dw      0111111100000000b      
        dw      0100111100000000b      
        dw      0011101000000000b      
        dw      0011100000000000b      
        dw      0001101000000000b      
        dw      0001101000000000b      
        db      6     
        dw      1111111100000000b      
        dw      0011011000000000b      
        dw      0100111000000000b      
        dw      0111111000000000b      
        dw      1011010110000000b      
        dw      1011010100000000b      
        dw      0111010110000000b      
        dw      0100010110000000b      
        dw      0011111100000000b      
        dw      0011010100000000b      
        dw      1101101000000000b      
        dw      0001101000000000b      
        db      6     
        dw      1111001100000000b      
        dw      1010001100000000b      
        dw      0100111000000000b      
        dw      0100011000000000b      
        dw      1011010100000000b      
        dw      1010000100000000b      
        dw      0100010110000000b      
        dw      0100010110000000b      
        dw      0011111000000000b      
        dw      0010111000000000b      
        dw      1101101000000000b      
        dw      0101001000000000b      
        db      6     
        dw      0100100100000000b      
        dw      0100000100000000b      
        dw      0010011010000000b      
        dw      0010001000000000b      
        dw      0001010100000000b      
        dw      0000000100000000b      
        dw      0100010000000000b      
        dw      0100010000000000b      
        dw      0001001010000000b      
        dw      0001001000000000b      
        dw      1001101000000000b      
        dw      1000101000000000b      
        db      6     
        dw      0101001000000000b      
        dw      0100001000000000b      
        dw      0010000000000000b      
        dw      0010000000000000b      
        dw      0000000100000000b      
        dw      0000000100000000b      
        dw      0100000010000000b      
        dw      0100000010000000b      
        dw      0010001000000000b      
        dw      0010001000000000b      
        dw      1010101000000000b      
        dw      1000101000000000b      
        db      6     
        dw      0000100000000000b      
        dw      0000100000000000b      
        dw      1100001000000000b      
        dw      1100000000000000b      
        dw      0000000000000000b      
        dw      0000000000000000b      
        dw      0010000000000000b      
        dw      0010000000000000b      
        dw      0000000110000000b      
        dw      0000000110000000b      
        dw      0011000000000000b      
        dw      0011000000000000b      
        db      6     
        dw      0000010000000000b      
        dw      0000010000000000b      
        dw      0000000000000000b      
        dw      0000000000000000b      
        dw      0100000000001000b      
        dw      0100000000000000b      
        dw      0000000000000000b      
        dw      0000000000000000b      
        dw      0000000000000000b      
        dw      0000000000000000b      
        dw      0000000100000000b      
        dw      0000000100000000b      
explode_end:
