;------ Platinum Editon for Casio Algebra FX 2.0 - Simple input/output
;
; Programmed by Patrick Davidson (pad@ocf.berkeley.edu)
;
; This software is in the public domain.  There is no warranty.

;------ simple input/output

get_keystroke:                  ; get keystroke (AH=scancode, AL=character)
        mov     ah,1
        int     0x16
        je      .c
        mov     ah,0
        int     0x16
        ret
.c:     xor     ax,ax
        ret

move_cursor:                    ; move to row DH, column DL
        mov     ah,2
        xor     bh,bh
        int     0x10
        ret

display_string:                 ; display string at SI
        lodsb
        or      al,al
        je      .q
        call    display_char
        jmp     display_string
.q:     ret

display_char:
        mov     ah,0x0e
        xor     bx,bx
        int     0x10
        ret

display_number:                 ; display number AX (end at row DH, col DL)
        mov     cx,5
.dn:    push    cx
        push    dx
        push    ax
        call    move_cursor
        pop     ax
        xor     dx,dx
        mov     cx,10
        div     cx
        push    ax
        mov     al,dl
        add     al,'0'
        call    display_char   
        pop     ax
        pop     dx
        dec     dl
        pop     cx
        loop    .dn
        ret
