;------ Platinum Editon 0.01 for Casio Algebra FX 2.0
;
; Calculator-specific routines
;
; Programmed by Patrick Davidson (pad@ocf.berkeley.edu)
;
; This software is in the public domain.  There is no warranty.

K_ESC   equ     1

;------ initialize and exit

SEGMENT _TEXT class=CODE

        GLOBAL  _main

_main:
        mov     ax,0x40
        mov     es,ax
        mov     ax,[es:0xe0]
        mov     [_segm_video],ax

        mov     es,ax
        xor     di,di
        mov     cx,512
        xor     ax,ax
        rep     stosw

        mov     ax,_TEXT
        mov     ds,ax
        mov     es,ax

        call    main_game

        mov     al,[save_available]
        or      al,al
        jz      exit
        
        push    word save_end-ident     ; length
        push    word 0                  ; offset
        push    word ident              ; source
        push    word b_struct           ; basic file structure
        call    _write_toBfile
        add     sp,8

exit:   
        mov     ax,0x4c00
        int     0x21

text_mode:
        mov     cx,[contrast]
dcl:    push    cx
        call    lighten_screen
        pop     cx
        loop    dcl

        mov     al,0xe3
        out     2,al
clear_screen:
        mov     ax,3
        int     0x10
        ret

;------ test keys

check_shoot:
        mov     al,0xdb
        out     2,al
        mov     ax,0000000100000000b
        out     0x13,ax
        mov     cx,20
.wait:  loop    .wait
        in      al,0x13
        and     al,0x20
        ret

check_left:
        mov     ax,0000001000000000b
        out     0x13,ax
        mov     cx,20
.wait:  loop    .wait
        in      al,0x13
        and     al,0x40
        ret

check_right:
        mov     ax,0000001000000000b
        out     0x13,ax
        mov     cx,20
.wait:  loop    .wait
        in      al,0x13
        and     al,8
        ret

check_up:
        mov     ax,0000001000000000b
        out     0x13,ax
        mov     cx,20
.wait:  loop    .wait
        in      al,0x13
        and     al,0x20
        ret

check_down:
        mov     ax,0000001000000000b
        out     0x13,ax
        mov     cx,20
.wait:  loop    .wait
        in      al,0x13
        and     al,0x10
        ret

is_exit:
        cmp     ah,1
        ret

;------ delay

delay:  mov     al,[speed]
        sub     al,'9'
        neg     al
        cbw
        mov     cx,1000
        mul     cx
        mov     cx,ax
        inc     cx
.dl:    loop    .dl
        ret

graphics_mode:
        mov     cx,[contrast]
icl:    push    cx
        call    darken_screen
        pop     cx
        loop    icl
        mov     al,0xdb
        out     2,al
        ret

;------ copy screen buffer to display / contrast change

display_screen:
        push    es
        mov     ax,[_segm_video]
        mov     es,ax

        xor     di,di
        mov     si,scrn
        mov     cx,512
        rep     movsw

        add     di,1024
        mov     cx,512
        rep     movsw

        pop     es
        ret

darken_screen:
        mov     ah,0x22
        xor     bl,bl
        int     0x7c
        ret

lighten_screen:
        mov     ah,0x22
        mov     bl,1
        int     0x7c
        ret

        GLOBAL  _segm_video

_segm_video:
        dw      0

        EXTERN  _read_toBfile
        EXTERN  _write_toBfile
        EXTERN  _search_basic_file

%include "platinum.asm"
