;------ final scoring

final_score:
        mov     bx,[score]              ; 1 point per enemy killed (700)

        mov     al,[finished]
        or      al,al
        jz      .no_win_bonus
        add     bx,1000                 ; 1000 points victory bonus (1000)
        xor     ah,ah
        mov     al,[player_shield]
        mov     cx,150
        mul     cx                      ; 150 points per shield (2400)
        add     bx,ax
.no_win_bonus:
        mov     ax,[cash]
        mov     cx,5
        xor     dx,dx
        div     cx                      ; 1/5 point per $ cash (800)
        add     bx,ax

        xor     dx,dx
        mov     al,[speed]
        sub     al,'0'-3
        cbw                             ; multiplier 3 to 12 based on speed
        mul     bx
        mov     [score],ax

        call    text_mode
        xor     dx,dx
        call    move_cursor
        mov     si,score_message
        call    display_string
        mov     dx,0x0113
        mov     ax,[score]
        call    display_number
        mov     dx,0x0200
        call    move_cursor

        mov     ax,[score]
        cmp     ax,[last_score]
        ja      new_highscore

        mov     si,nohigh_message
        call    display_string
.l:     call    get_keystroke
        cmp     ah,63
        jnz     .l
        jmp     display_scorest

display_scores:
        call    text_mode
display_scorest:

        call    clear_screen 

        xor     dx,dx
        call    move_cursor
        mov     si,table_message
        call    display_string

        mov     cx,6
        mov     si,score_table
loop_scores:
        mov     dx,0x700
        sub     dh,cl
        push    cx
        push    si
        call    move_cursor
        pop     si
        push    si
        call    display_string
        pop     si
        pop     cx
        push    cx
        push    si
        mov     ax,[si+16]
        mov     dx,0x714
        sub     dh,cl
        call    display_number
        pop     si
        pop     cx
        add     si,18
        loop    loop_scores

.l:     call    get_keystroke
        cmp     ah,62
        jnz     .l
        ret

read_complete:
        mov     si,last_score
        mov     cx,5
sort_loop:
        mov     ax,[si]
        cmp     ax,[si-18]
        jb      display_scores
        push    cx
        mov     cx,9
loop_exchange:
        mov     ax,[si]
        mov     bx,[si-18]
        mov     [si-18],ax
        mov     [si],bx
        add     si,-2
        loop    loop_exchange
        pop     cx
        loop    sort_loop
        jmp     display_scorest

new_highscore:
        mov     [last_score],ax
        mov     si,name_prompt
        call    display_string

        mov     di,lastname
        mov     al,' '
        mov     cx,15
        rep     stosb

        mov     di,lastname
show_partial_name:
        push    di
        mov     dx,0x700
        call    move_cursor
        mov     si,lastname
        call    display_string
        pop     di
loop_read_name:
        push    di
        call    get_keystroke
        pop     di
        cmp     ah,63
        jz      read_complete
        cmp     ah,28
        jz      read_complete
        cmp     ah,83
        jz      delete_char
        or      al,al
        jz      loop_read_name
        cmp     di,lastname+15
        jz      loop_read_name
        cmp     al,48
        jl      key_space
        cmp     al,64
        jl      index_key
        stosb
        jmp     show_partial_name

key_space:
        inc     di
        jmp     loop_read_name

index_key:
        mov     si,index_key_table-48
        xor     ah,ah
        add     si,ax
        movsb
        jmp     show_partial_name

delete_char
        cmp     di,lastname
        jz      loop_read_name
        dec     di
        mov     byte [di],' '
        jmp     show_partial_name

index_key_table:
        db      "ZUVWPQRMNO"

score_message:
        db      "Game over - Your",10,13
        db      "final score is 00000.",0

nohigh_message:
        db      "You do not have a",10,13
        db      "highscore.  Press F5",10,13
        db      "to continue.",0

name_prompt:
        db      "You have set a high",10,13
        db      "score!  Type in your",10,13
        db      "name and press F5.",0

table_message:
        db      "All-Time Highscores"
        db      10,13,10,13,10,13,10,13,10,13,10,13,10,13
        db      "Press F4 to exit",0

