;------ Platinum Editon for Casio Algebra FX 2.0 - Shop
;
; Programmed by Patrick Davidson (pad@ocf.berkeley.edu)
;
; This software is in the public domain.  There is no warranty.

;------ shop handling

level_shop:
        mov     ax,[cash]
        cmp     ax,50
        jnc     .draw_shop
        ret

.draw_shop:
        call    get_keystroke
        call    text_mode
        xor     dx,dx
        call    move_cursor
        mov     si,shop_message
        call    display_string
        mov     byte [shop_position],2
.shop_loop:
        mov     ax,[cash]
        cmp     ax,50
        jc      .exit_shop
        mov     ax,[cash]
        mov     dx,20
        call    display_number
        mov     dh,[shop_position]
        xor     dl,dl
        call    move_cursor
        mov     al,'>'
        call    display_char
.w:     call    get_keystroke
        or      ah,ah
        jz      .w
        cmp     ah,72
        jz      .go_up
        cmp     ah,80
        jz      .go_down
        cmp     ah,59
        jz      .select
        call    is_exit
        jnz     .shop_loop
.exit_shop:
        jmp     graphics_mode

.go_up: mov     dh,[shop_position]
        cmp     dh,2
        jz      .shop_loop
        dec     byte [shop_position]

.erase_cursor:
        xor     dl,dl
        call    move_cursor
        mov     al,' '
        call    display_char
        jmp     .shop_loop

.go_down:
        mov     dh,[shop_position]
        cmp     dh,7
        jz      .shop_loop
        inc     byte [shop_position]
        jmp     .erase_cursor

.select:
        push    word level_shop.shop_loop
        mov     al,[shop_position]
        cbw
        add     ax,ax
        mov     di,shop_table-4
        add     di,ax
        jmp     [di]

shop_table:
        dw      shop_exit
        dw      buy_shield
        dw      buy_weapon2
        dw      buy_weapon3
        dw      buy_rapid
        dw      buy_weapon4

buy_weapon2:
        mov     cx,[cash]
        sub     cx,200
        jl      .q
        mov     al,[weapon_f2]
        or      al,al
        jnz     .q
        inc     al
        mov     [weapon_selected],al
        mov     [weapon_f2],al
        mov     [cash],cx
.q:     ret

buy_weapon3:
        mov     cx,[cash]
        sub     cx,500
        jl      .q
        mov     al,[weapon_f3]
        or      al,al
        jnz     .q
        mov     al,2 
        mov     [weapon_selected],al
        mov     [weapon_f3],al
        mov     [cash],cx
.q:     ret

buy_rapid:
        mov     cx,[cash]
        sub     cx,1000
        jl      .q
        mov     al,[fire_delay]
        cmp     al,3
        jz      .q
        mov     byte [fire_delay],3
        mov     [cash],cx
.q      ret

buy_weapon4:
        mov     cx,[cash]
        sub     cx,1500
        jl      .q
        mov     al,[weapon_f4]
        or      al,al
        jnz     .q
        mov     al,3
        mov     [weapon_selected],al
        mov     [weapon_f4],al
        mov     [cash],cx
.q:     ret

buy_shield:
        mov     al,[player_shield]
        cmp     al,16
        jz      .q
        inc     al
        mov     [player_shield],al
        mov     cx,[cash]
        sub     cx,50
        mov     [cash],cx
.q:     ret

shop_exit:
        pop     ax
        jmp     graphics_mode

shop_message:
        db      "Platinum Shop $0000",10,13
        db      "Use F1, up, down",10,13
        db      "> Exit the shop",10,13
        db      "  $50 Shield boost",10,13
        db      "  $200 Weapon F2",10,13
        db      "  $500 Weapon F3",10,13
        db      "  $1000 Rapid Fire",10,13
        db      "  $1500 Weapon F4",0

