;------ Platinum Editon for Casio Algebra FX 2.0 - Title screens
;
; Programmed by Patrick Davidson (pad@ocf.berkeley.edu)
;
; This software is in the public domain.  There is no warranty.

;-------------- main title screen

title_screen:
        call    draw_background
        call    draw_foreground
        mov     cl,29
        mov     ch,33
        mov     si,platinum_txt
        call    display_string_gray
        mov     cl,34
        mov     ch,43
        mov     si,edition_txt
        call    display_string_gray
        mov     cl,34
        mov     ch,57
        mov     si,f1_txt
        call    display_string_gray
        mov     cl,29
        mov     ch,67
        mov     si,f2_txt
        call    display_string_gray
        mov     cl,20
        mov     ch,77
        mov     si,f3_txt
        call    display_string_gray
        mov     cl,29
        mov     ch,87
        mov     si,f4_txt
        call    display_string_gray
        call    delay
        call    display_screen
        call    get_keystroke
        call    do_contrast
        call    is_exit
        je      title_exit

        cmp     ah,61
        je      title_options

        cmp     ah,60
        je      .go_about

        cmp     ah,59
        je      .go_help

        cmp     ah,62
        jne     title_screen
        ret

.go_about:
        jmp     about_screen

.go_help:
        jmp     help_screen

title_exit:
        pop     ax
        jmp     main_loop.exit2
        ret

platinum_txt:
        db      "PLATINUM",0

edition_txt:
        db      "EDITION",0

f1_txt: db      "F1:HELP",0
f2_txt: db      "F2:ABOUT",0
f3_txt: db      "F3:OPTIONS",0
f4_txt: db      "F4:START",0

;-------------- options screen

title_options:
        call    draw_background
        call    draw_foreground

        mov     cl,34
        mov     ch,32
        mov     si,o1           
        call    display_string_gray
        mov     cl,20
        mov     ch,42
        mov     si,o2           
        call    display_string_gray
        mov     cl,25
        mov     ch,50
        mov     si,o3           
        call    display_string_gray
        mov     cl,29
        mov     ch,58
        mov     si,o4           
        call    display_string_gray
        mov     cl,25
        mov     ch,68
        mov     si,o5           
        call    display_string_gray
        mov     cl,25
        mov     ch,76
        mov     si,o6           
        call    display_string_gray
        mov     cl,25
        mov     ch,88
        mov     si,o7           
        call    display_string_gray

        call    delay
        call    display_screen
        call    get_keystroke
        call    do_contrast
        call    is_exit
        je      .title_exit

        cmp     ah,63
        jne     .nr
        jmp     title_screen

.nr:    cmp     al,'0'
        jl      title_options
        cmp     al,'9'
        jg      title_options
        mov     [speed],al
        jmp     title_options

.title_exit:
        jmp     title_exit

o1:     db      "OPTIONS",0

o2:     db      "PLUS MINUS",0
o3:     db      "TO ADJUST",0
o4:     DB      "CONTRAST",0

o5:     db      "0 TO 9 TO",0
o6:     db      "SET SPEED",0

o7:     db      "F5:RETURN",0

;-------------- Help screen

help_screen:
        call    draw_background
        call    draw_foreground

        mov     cl,29
        mov     ch,32
        mov     si,a1           
        call    display_string_gray
        mov     cl,20
        mov     ch,42
        mov     si,a2           
        call    display_string_gray
        mov     cl,20
        mov     ch,50
        mov     si,a3
        call    display_string_gray
        mov     cl,34
        mov     ch,60
        mov     si,a4           
        call    display_string_gray
        mov     cl,29
        mov     ch,68
        mov     si,a5           
        call    display_string_gray
        mov     cl,20
        mov     ch,76
        mov     si,a6           
        call    display_string_gray
        mov     cl,25
        mov     ch,88
        mov     si,a7           
        call    display_string_gray

        call    delay
        call    display_screen
        call    get_keystroke
        call    do_contrast
        call    is_exit
        je      .title_exit
        cmp     ah,63
        jnz     help_screen
        jmp     title_screen

.title_exit:
        jmp     title_exit

a1:     db      "CONTROLS",0

a2:     db      "CURSOR PAD",0
a3:     db      "MOVES SHIP",0

a4:     db      "F6:SAVE",0
a5:     db      "ESC:QUIT",0
a6:     db      "CTRL:SHOOT",0

a7:     db      "F5:RETURN",0

;-------------- About

about_screen:
        call    text_mode

        xor     dx,dx
        call    move_cursor
        mov     si,about_message
        call    display_string
.error_loop:
        call    get_keystroke
        cmp     ah,63
        jnz     .error_loop
        call    graphics_mode
        jmp     title_screen

about_message:
        db      "Platinum Edition 0.51"
        db      " by Patrick Davidson",10,13
        db      "E-Mail - pad@calc.org"
        db      "http://pad.calc.org/",10,13
        db      "There is no warranty",10,13
        db      "for this program.",10,13,10,13
        db      "Press F5 to return",0

;-------------- Contrast adjusting

do_contrast:
        cmp     al,88
        je      contrast_up
        cmp     al,89
        je      contrast_down
        ret

contrast_up:
        mov     al,[contrast]
        cmp     al,16
        jz      .back
        inc     al
        mov     [contrast],al
        call    darken_screen
.back:  xor     al,al
        ret

contrast_down:
        mov     al,[contrast]
        cmp     al,1
        jz      .back
        dec     al
        mov     [contrast],al
        call    lighten_screen
.back:  xor     al,al
        ret
